=== debian/changelog ===
pistache (0.0.002-pistache1) groovy; urgency=medium

  * Latest upstream.

 -- Kip Warner <kip@thevertigo.com>  Sun, 27 Dec 2020 16:40:00 -0700
