=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/pistache-$1\.tar\.gz/ \
  https://github.com/pistacheio/pistache/tags .*/v?(\d\S*)\.tar\.gz
